//BroderieGeometrique_501f.js
//Une extension du script "MysticRose.jsx" par Olav Kvern
// 12.10.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Dessine une "mystic rose" (une construction geomtrique)

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// dfinir "Aucun" ou "Sans"
var noColor = "[Sans]";
var rgColor = "[Reprage]";
if (app.version[0] == 4) {
	noColor = "[Aucun]";
	rgColor = "[Reprage]";
}

if (app.documents.length!=0) {
	if (app.activeWindow.constructor.name == "LayoutWindow") {
		curDoc = app.documents[0];
		// appeler la fonction qui lit les prfrences mmorises
		var allPrefs = getPrefs();
		if (allPrefs != "") {
			var prefVal = allPrefs.split("\n");
			var xPos  = prefVal[0]*1;
			var yPos  = prefVal[1]*1;
			var curD  = prefVal[2]*1;
			var nPts  = prefVal[3]*1;
			var bName = prefVal[4];
			if (bName == "Black") { bName = "[Noir]"; }
			else if (bName == "Paper") { bName = "[Papier]"; }
			else if (bName == "Registration") { bName = rgColor; }
			else if (bName == "None") { bName = noColor; }
			var bgrT  = prefVal[5]*1;
			var ck0   = true;
			var eoFll = prefVal[6];
			if (eoFll == "false") {
				ck0 = false;
			}
			var sName = prefVal[7];
			if (sName == "Black") { sName = "[Noir]"; }
			else if (sName == "Paper") { sName = "[Papier]"; }
			else if (sName == "Registration") { sName = rgColor; }
			else if (sName == "None") { sName = noColor; }
			var strT  = prefVal[8]*1;
			var strW  = prefVal[9]*1;
			var alig  = prefVal[10];
			var ck1 = 1;
			var ck2 = 0;
			var ck3 = 0;
			if (alig == "1") {
				ck1 = 0;
				ck2 = 1;
			}
			else if (alig == "2") {
				ck1 = 0;
				ck3 = 1;
			}
		}
		else {
			// utiliser les valeurs par dfaut 
			// quand le fichier des prfrences n'existe pas
			var xPos =  100;
			var yPos =  100;
			var curD =  100;
			var nPts =   21;
			var bgrT =   70;
			var ck0  = true;
			var strT =  100;
			var strW = 0.25;
			var ck1  =    1;
			var ck2  =    0;
			var ck3  =    0;
			var bName = "C=0 M=100 J=0 N=0";
			var sName = "[Noir]";
		}
		
		// appeler les fonctions qui prparent les listes des couleurs
		var bgrColor = getBgrColorList(bName);
		var bgrCol   = bgrColor[0];
		var bInd     = bgrColor[1];
		var strColor = getStrColorList(sName);
		var strCol   = strColor[0];
		var sInd     = strColor[1];
		
		// mmoriser les units de mesure
		// si ce n'est pas 2053991795 (= millimtres), modifier  millimtres
		hM = curDoc.viewPreferences.horizontalMeasurementUnits;
		vM = curDoc.viewPreferences.verticalMeasurementUnits;
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
		}
		// mettre le point zro  zro/zro
		var zP = curDoc.zeroPoint; 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = [0,0]; 
		}
		
		// appeler la fonction qui affiche le dialogue
		var anArray = displayDialog(xPos, yPos, curD, nPts, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3);
		var centerPoint = anArray[0];
		var curDiameter = anArray[1];
		var nPoints     = anArray[2];
		var bColor      = anArray[3];
		var bgrT        = anArray[4];
		var evenOddFill = anArray[5];
		var sColor      = anArray[6];
		var strT        = anArray[7];
		var strW        = anArray[8];
		var strA        = anArray[9];
		// appeler la fonction qui calcule les polygones
		var curPathPoints = calculatePolygon(centerPoint, curDiameter/2, nPoints);
		// appeler la fonction qui dessine la rose
		drawMagicRose(curPathPoints, nPoints, bColor, bgrT, evenOddFill, sColor, strT, strW, strA);
		
		// restaurer le point zro (si ncessaire)
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		
		// restaurer les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
	}
}

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les rglages mmoriss
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/broderie.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// la fonction qui prpare la liste des couleurs pour le fond
function getBgrColorList(bName) {
	// dfinir une variable comme rfrence aux nuances du document actif
	var allSwatches = curDoc.swatches;
	
	// vrifier si la couleur mmorise existe
	if (bName != "[Noir]" && bName != "[Papier]" && bName != noColor && bName != rgColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = "[Noir]";
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Paper", "Black" et "Registration";
	// relever la position de la couleur mmorise
	var bgrColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[Noir]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		if (cName != "Registration") {
			bgrColorList.push(cName);
		}
	}
	return [bgrColorList, bIndex];
}

// la fonction qui prpare la liste des couleurs du contour
function getStrColorList(sName) {
	// dfinir une variable comme rfrence aux nuances du document actif
	var allSwatches = curDoc.swatches;
	
	// vrifier si la couleur mmorise existe
	if (sName != "[Noir]" && sName != "[Papier]" && sName != noColor && sName != rgColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = "[Noir]";
		}
	}
	
	// assembler la liste des couleurs;
	// renommer "None", "Paper", "Black" et "Registration";
	// relever la position de la couleur mmorise
	var strColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = "[Papier]";
		}
		else if (cName == "Black") {
			cName = "[Noir]";
		}
		else if (cName == "Registration") {
			cName = rgColor;
		}
		if (sName == cName) {
			sIndex = i;
		}
		if (cName != "Registration") {
			strColorList.push(cName);
		}
	}
	return [strColorList, sIndex];
}

// prparer et afficher le dialogue
function displayDialog(xPos, yPos, curD, nPts, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 90;
	var fieldWidth = 40;
	var aDialog = app.dialogs.add({name:"BroderieGeometrique"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Le centre", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"X:"});
			}
			with (dialogColumns.add()) {
				var xField = realEditboxes.add({editValue:xPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Y:"});
			}
			with (dialogColumns.add()) {
				var yField = realEditboxes.add({editValue:yPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		labelWidth = 115;
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Diamtre", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var curDiameterField = realEditboxes.add({editValue:curD, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Nombre de points", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var nPointsField = integerEditboxes.add({editValue:nPts, minimumValue:5, maximumValue:39, minWidth:fieldWidth});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le fond de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Teinte", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		var evenOddCheckbox = checkboxControls.add({staticLabel:"Remplissage altern", checkedState:ck0});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Le contour de l'objet", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Teinte", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Epaisseur", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Alignement", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"centrer", checkedState:ck1});
						radiobuttonControls.add({staticLabel:"intrieur", checkedState:ck2});
						radiobuttonControls.add({staticLabel:"extrieur", checkedState:ck3});
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var x = xField.editValue;
		var y = yField.editValue;
		var curDiameter = curDiameterField.editValue;
		var nPoints = nPointsField.editValue;
		if ((nPoints%2) == 0) {
			alert ("Le nombre de points devrait tre un chiffre *impair*.", "Attention");
		}
		bgrIndex = bgrColor.selectedIndex;
		bColor = curDoc.swatches[bgrIndex].name;
		if (bColor == "[Noir]") { bColor = "Black"; }
		else if (bColor == "[Papier]") { bColor = "Paper"; }
		else if (bColor == rgColor) { bColor = "Registration"; }
		else if (bColor == noColor) { bColor = "None"; }
		bgrT = bgrTint.editValue;
		var ck0 = evenOddCheckbox.checkedState;
		strIndex = strColor.selectedIndex;
		sColor = curDoc.swatches[strIndex].name;
		if (sColor == "[Noir]") { sColor = "Black"; }
		else if (sColor == "[Papier]") { sColor = "Paper"; }
		else if (sColor == rgColor) { sColor = "Registration"; }
		else if (sColor == noColor) { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // centrer
		}
		else if (aligDec == 1) {
			strA = 1936998729; // intrieur
		}
		else if (aligDec == 2) {
			strA = 1936998735; // extrieur
		}
		aDialog.destroy();
		var prefsList = new Array (x, y, curDiameter, nPoints, bColor, bgrT, ck0, sColor, strT, strW, aligDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		return [[x, y], curDiameter, nPoints, bColor, bgrT, ck0, sColor, strT, strW, strA];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/broderie.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// cette fonction calcule les points pour un polygone avec n bords autour d'un centre
function calculatePolygon(centerPoint, curRadius, nPoints) {
	angleIncrement = (360/nPoints)*(Math.PI/180);
	var curPathPoints = new Array;
	for (pointCounter = 0; pointCounter < nPoints;pointCounter ++) {
		x = centerPoint[0] + (curRadius * Math.cos(angleIncrement*pointCounter));
		y = centerPoint[1] + (curRadius * Math.sin(angleIncrement*pointCounter));
		curPathPoints.push([x, y]);
	}
	return curPathPoints;
}

// la fonction qui dessine la rose
function drawMagicRose(curPathPoints, nPoints, bColor, bgrT, ck0, sColor, strT, strW, strA) {
	// lister les points  sauter
	var skipArray = new Array ();
	var nVals = Math.floor(nPoints/2)+1;
	for (var v=1; v<nVals; v++) {
		skipArray.push(v);
	}
	// dfinir d'autres variables
	var isDone = false;
	var ctr = 1;
	var curIndex = 0;
	var newPathPoints = new Array;
	newPathPoints.push(curPathPoints[0]);
	do {
		for (var skipCounter = 0; skipCounter < skipArray.length; skipCounter++) {
			var curIndex = (curIndex + skipArray[skipCounter])%curPathPoints.length;
			newPathPoints.push(curPathPoints[curIndex]);
		}
		if (curIndex == 0) {
			// l'action est termine lorsque le point initial est atteint  la fin de la squence
			// N.-B.: le point initial peut tre visit plusieurs fois * l'intrieur* de la squence
			isDone = true;
		}
		else {
			ctr ++;
		}
	} while (isDone != true);
	bColor = curDoc.swatches.itemByName(bColor);
	sColor = curDoc.swatches.itemByName(sColor);
	var curPolygon = app.activeWindow.activePage.polygons.add();
	curPolygon.paths.item(0).entirePath = newPathPoints;
	if (ck0 == true) {
		var newPolygon = curPolygon.duplicate();
		curPolygon.addPath(newPolygon);
		newPolygon.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
	}
	else {
		curPolygon.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
	}
}